#!/bin/sh

load_firmware()
(
  FIRMWARE=$1
  echo "Loading $FIRMWARE:"
  i=0
  while [ $i -lt 3 ]; do
    i=$(($i + 1))
    ping -c1 "mld6.minidvblinux.de" > /dev/null && break
    sleep 5
  done
  mkdir -p "/lib/firmware/$(dirname $FIRMWARE)"
  wget "https://mld6.minidvblinux.de/firmware/$FIRMWARE" -O "/lib/firmware/$FIRMWARE"
)


if [ "$1" ]; then

  DEVPATH="$1"
  FIRMWARE=${DEVPATH##*/}
  FIRMWARE=${FIRMWARE//\!//}

  if [ ! -e "/lib/firmware/$FIRMWARE.not_found" ]; then
    load_firmware $FIRMWARE

    if [ -e "/lib/firmware/$FIRMWARE" ]; then
      rm -f "/lib/firmware/$FIRMWARE.not_found"
      echo 1 > "/$DEVPATH/loading" 2>/dev/null
      cat "/lib/firmware/$FIRMWARE" > "/$DEVPATH/data" 2>/dev/null
    else
      ls -l "/${DEVPATH%firmware/*}driver" 2>/dev/null | sed "s/.*\///" > "/lib/firmware/$FIRMWARE.not_found"
      echo "Failed to load $FIRMWARE"
    fi
  fi
  echo 0 > "/$DEVPATH/loading" 2>/dev/null

elif [ -d /lib/firmware ]; then

  # Attempts to load firmware that could not be loaded at boot time, e.g. because there was no network connection yet
  find /lib/firmware/ -name *.not_found | while read firmware; do
    FIRMWARE=${firmware%.not_found}
    FIRMWARE=${FIRMWARE#/lib/firmware/}

    load_firmware $FIRMWARE

    if [ -e "/lib/firmware/$FIRMWARE" ]; then
      module=$(cat "/lib/firmware/$FIRMWARE.not_found")
      if [ "$module" ]; then
        modprobe -r $module && modprobe $module
      fi
      rm "/lib/firmware/$FIRMWARE.not_found"
    else
      echo "Failed to load $FIRMWARE"
    fi
  done

fi
